ace.define("ace/mode/sh_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(r,l,y){"use strict";var c=r("../lib/oop"),h=r("./text_highlight_rules").TextHighlightRules,s=l.reservedKeywords="!|{|}|case|do|done|elif|else|esac|fi|for|if|in|then|until|while|&|;|export|local|read|typeset|unset|elif|select|set|function|declare|readonly",d=l.languageConstructs="[|]|alias|bg|bind|break|builtin|cd|command|compgen|complete|continue|dirs|disown|echo|enable|eval|exec|exit|fc|fg|getopts|hash|help|history|jobs|kill|let|logout|popd|printf|pushd|pwd|return|set|shift|shopt|source|suspend|test|times|trap|type|ulimit|umask|unalias|wait",e=function(){var _=this.createKeywordMapper({keyword:s,"support.function.builtin":d,"invalid.deprecated":"debugger"},"identifier");this.$rules={start:[{token:"constant",regex:/\\./},{token:["text","comment"],regex:/(^|\s)(#.*)$/},{token:"string.start",regex:'"',push:[{token:"constant.language.escape",regex:/\\(?:[$`"\\]|$)/},{include:"variables"},{token:"keyword.operator",regex:/`/},{token:"string.end",regex:'"',next:"pop"},{defaultToken:"string"}]},{token:"string",regex:"\\$'",push:[{token:"constant.language.escape",regex:/\\(?:[abeEfnrtv\\'"]|x[a-fA-F\d]{1,2}|u[a-fA-F\d]{4}([a-fA-F\d]{4})?|c.|\d{1,3})/},{token:"string",regex:"'",next:"pop"},{defaultToken:"string"}]},{regex:"<<<",token:"keyword.operator"},{stateName:"heredoc",regex:"(<<-?)(\\s*)(['\"`]?)([\\w\\-]+)(['\"`]?)",onMatch:function(u,v,a){var M="-"==u[2]?"indentedHeredoc":"heredoc",k=u.split(this.splitRegex);return a.push(M,k[4]),[{type:"constant",value:k[1]},{type:"text",value:k[2]},{type:"string",value:k[3]},{type:"support.class",value:k[4]},{type:"string",value:k[5]}]},rules:{heredoc:[{onMatch:function(u,v,a){return u===a[1]?(a.shift(),a.shift(),this.next=a[0]||"start","support.class"):(this.next="","string")},regex:".*$",next:"start"}],indentedHeredoc:[{token:"string",regex:"^\t+"},{onMatch:function(u,v,a){return u===a[1]?(a.shift(),a.shift(),this.next=a[0]||"start","support.class"):(this.next="","string")},regex:".*$",next:"start"}]}},{regex:"$",token:"empty",next:function(u,v){return"heredoc"===v[0]||"indentedHeredoc"===v[0]?v[0]:u}},{token:["keyword","text","text","text","variable"],regex:/(declare|local|readonly)(\s+)(?:(-[fixar]+)(\s+))?([a-zA-Z_][a-zA-Z0-9_]*\b)/},{token:"variable.language",regex:"(?:\\$(?:SHLVL|\\$|\\!|\\?))"},{token:"variable",regex:"(?:[a-zA-Z_][a-zA-Z0-9_]*(?==))"},{include:"variables"},{token:"support.function",regex:"(?:[a-zA-Z_][a-zA-Z0-9_]*\\s*\\(\\))"},{token:"support.function",regex:"(?:&(?:\\d+))"},{token:"string",start:"'",end:"'"},{token:"constant.numeric",regex:"(?:(?:(?:(?:(?:(?:\\d+)?(?:\\.\\d+))|(?:(?:\\d+)\\.))|(?:\\d+)))|(?:(?:(?:\\d+)?(?:\\.\\d+))|(?:(?:\\d+)\\.)))"},{token:"constant.numeric",regex:"(?:(?:[1-9]\\d*)|(?:0))\\b"},{token:_,regex:"[a-zA-Z_][a-zA-Z0-9_]*\\b"},{token:"keyword.operator",regex:"\\+|\\-|\\*|\\*\\*|\\/|\\/\\/|~|<|>|<=|=>|=|!=|[%&|`]"},{token:"punctuation.operator",regex:";"},{token:"paren.lparen",regex:"[\\[\\(\\{]"},{token:"paren.rparen",regex:"[\\]]"},{token:"paren.rparen",regex:"[\\)\\}]",next:"pop"}],variables:[{token:"variable",regex:/(\$)(\w+)/},{token:["variable","paren.lparen"],regex:/(\$)(\()/,push:"start"},{token:["variable","paren.lparen","keyword.operator","variable","keyword.operator"],regex:/(\$)(\{)([#!]?)(\w+|[*@#?\-$!0_])(:[?+\-=]?|##?|%%?|,,?\/|\^\^?)?/,push:"start"},{token:"variable",regex:/\$[*@#?\-$!0_]/},{token:["variable","paren.lparen"],regex:/(\$)(\{)/,push:"start"}]},this.normalizeRules()};c.inherits(e,h),l.ShHighlightRules=e}),ace.define("ace/mode/makefile_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules","ace/mode/sh_highlight_rules"],function(r,l,y){"use strict";var c=r("../lib/oop"),h=r("./text_highlight_rules").TextHighlightRules,s=r("./sh_highlight_rules"),d=function(){var e=this.createKeywordMapper({keyword:s.reservedKeywords,"support.function.builtin":s.languageConstructs,"invalid.deprecated":"debugger"},"string");this.$rules={start:[{token:"string.interpolated.backtick.makefile",regex:"`",next:"shell-start"},{token:"punctuation.definition.comment.makefile",regex:/#(?=.)/,next:"comment"},{token:["keyword.control.makefile"],regex:"^(?:\\s*\\b)(\\-??include|ifeq|ifneq|ifdef|ifndef|else|endif|vpath|export|unexport|define|endef|override)(?:\\b)"},{token:["entity.name.function.makefile","text"],regex:"^([^\\t ]+(?:\\s[^\\t ]+)*:)(\\s*.*)"}],comment:[{token:"punctuation.definition.comment.makefile",regex:/.+\\/},{token:"punctuation.definition.comment.makefile",regex:".+",next:"start"}],"shell-start":[{token:e,regex:"[a-zA-Z_$][a-zA-Z0-9_$]*\\b"},{token:"string",regex:"\\w+"},{token:"string.interpolated.backtick.makefile",regex:"`",next:"start"}]}};c.inherits(d,h),l.MakefileHighlightRules=d}),ace.define("ace/mode/folding/coffee",["require","exports","module","ace/lib/oop","ace/mode/folding/fold_mode","ace/range"],function(r,l,y){"use strict";var c=r("../../lib/oop"),h=r("./fold_mode").FoldMode,s=r("../../range").Range,d=l.FoldMode=function(){};c.inherits(d,h),function(){this.getFoldWidgetRange=function(e,_,t){var g=this.indentationBlock(e,t);if(g)return g;var n=/\S/,i=e.getLine(t),f=i.search(n);if(-1!=f&&"#"==i[f]){for(var o=i.length,p=e.getLength(),m=t,x=t;++t<p;){var b=(i=e.getLine(t)).search(n);if(-1!=b){if("#"!=i[b])break;x=t}}if(x>m){var $=e.getLine(x).length;return new s(m,o,x,$)}}},this.getFoldWidget=function(e,_,t){var g=e.getLine(t),n=g.search(/\S/),i=e.getLine(t+1),f=e.getLine(t-1),o=f.search(/\S/),p=i.search(/\S/);if(-1==n)return e.foldWidgets[t-1]=-1!=o&&o<p?"start":"","";if(-1==o){if(n==p&&"#"==g[n]&&"#"==i[n])return e.foldWidgets[t-1]="",e.foldWidgets[t+1]="","start"}else if(o==n&&"#"==g[n]&&"#"==f[n]&&-1==e.getLine(t-2).search(/\S/))return e.foldWidgets[t-1]="start",e.foldWidgets[t+1]="","";return e.foldWidgets[t-1]=-1!=o&&o<n?"start":"",n<p?"start":""}}.call(d.prototype)}),ace.define("ace/mode/makefile",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/makefile_highlight_rules","ace/mode/folding/coffee"],function(r,l,y){"use strict";var c=r("../lib/oop"),h=r("./text").Mode,s=r("./makefile_highlight_rules").MakefileHighlightRules,d=r("./folding/coffee").FoldMode,e=function(){this.HighlightRules=s,this.foldingRules=new d,this.$behaviour=this.$defaultBehaviour};c.inherits(e,h),function(){this.lineCommentStart="#",this.$indentWithTabs=!0,this.$id="ace/mode/makefile",this.snippetFileId="ace/snippets/makefile"}.call(e.prototype),l.Mode=e}),ace.require(["ace/mode/makefile"],function(r){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=r)});