ace.define("ace/mode/latex_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(a,d,b){"use strict";var h=a("../lib/oop"),f=a("./text_highlight_rules").TextHighlightRules,c=function(){this.$rules={start:[{token:"comment",regex:"%.*$"},{token:["keyword","lparen","variable.parameter","rparen","lparen","storage.type","rparen"],regex:"(\\\\(?:documentclass|usepackage|input))(?:(\\[)([^\\]]*)(\\]))?({)([^}]*)(})"},{token:["keyword","lparen","variable.parameter","rparen"],regex:"(\\\\(?:label|v?ref|cite(?:[^{]*)))(?:({)([^}]*)(}))?"},{token:["storage.type","lparen","variable.parameter","rparen"],regex:"(\\\\begin)({)(verbatim)(})",next:"verbatim"},{token:["storage.type","lparen","variable.parameter","rparen"],regex:"(\\\\begin)({)(lstlisting)(})",next:"lstlisting"},{token:["storage.type","lparen","variable.parameter","rparen"],regex:"(\\\\(?:begin|end))({)([\\w*]*)(})"},{token:"storage.type",regex:/\\verb\b\*?/,next:[{token:["keyword.operator","string","keyword.operator"],regex:"(.)(.*?)(\\1|$)|",next:"start"}]},{token:"storage.type",regex:"\\\\[a-zA-Z]+"},{token:"lparen",regex:"[[({]"},{token:"rparen",regex:"[\\])}]"},{token:"constant.character.escape",regex:"\\\\[^a-zA-Z]?"},{token:"string",regex:"\\${1,2}",next:"equation"}],equation:[{token:"comment",regex:"%.*$"},{token:"string",regex:"\\${1,2}",next:"start"},{token:"constant.character.escape",regex:"\\\\(?:[^a-zA-Z]|[a-zA-Z]+)"},{token:"error",regex:"^\\s*$",next:"start"},{defaultToken:"string"}],verbatim:[{token:["storage.type","lparen","variable.parameter","rparen"],regex:"(\\\\end)({)(verbatim)(})",next:"start"},{defaultToken:"text"}],lstlisting:[{token:["storage.type","lparen","variable.parameter","rparen"],regex:"(\\\\end)({)(lstlisting)(})",next:"start"},{defaultToken:"text"}]},this.normalizeRules()};h.inherits(c,f),d.LatexHighlightRules=c}),ace.define("ace/mode/folding/latex",["require","exports","module","ace/lib/oop","ace/mode/folding/fold_mode","ace/range","ace/token_iterator"],function(a,d,b){"use strict";var h=a("../../lib/oop"),f=a("./fold_mode").FoldMode,c=a("../../range").Range,k=a("../../token_iterator").TokenIterator,x={"\\subparagraph":1,"\\paragraph":2,"\\subsubsubsection":3,"\\subsubsection":4,"\\subsection":5,"\\section":6,"\\chapter":7,"\\part":8,"\\begin":9,"\\end":10},u=d.FoldMode=function(){};h.inherits(u,f),function(){this.foldingStartMarker=/^\s*\\(begin)|\s*\\(part|chapter|(?:sub)*(?:section|paragraph))\b|{\s*$/,this.foldingStopMarker=/^\s*\\(end)\b|^\s*}/,this.getFoldWidgetRange=function(t,n,o){var e,l=t.doc.getLine(o);return(e=this.foldingStartMarker.exec(l))?e[1]?this.latexBlock(t,o,e[0].length-1):e[2]?this.latexSection(t,o,e[0].length-1):this.openingBracketBlock(t,"{",o,e.index):(e=this.foldingStopMarker.exec(l))?e[1]?this.latexBlock(t,o,e[0].length-1):this.closingBracketBlock(t,"}",o,e.index+e[0].length):void 0},this.latexBlock=function(t,p,o,l){var e={"\\begin":1,"\\end":-1},r=new k(t,p,o),i=r.getCurrentToken();if(i&&("storage.type"==i.type||"constant.character.escape"==i.type)){var g=e[i.value],m=function(){var B="lparen"==r.stepForward().type?r.stepForward().value:"";return-1===g&&(r.stepBackward(),B&&r.stepBackward()),B},v=[m()],y=-1===g?r.getCurrentTokenColumn():t.getLine(p).length,R=p;for(r.step=-1===g?r.stepBackward:r.stepForward;i=r.step();)if(i&&("storage.type"==i.type||"constant.character.escape"==i.type)){var T=e[i.value];if(T){var w=m();if(T===g)v.unshift(w);else if(v.shift()!==w||!v.length)break}}if(!v.length)return 1==g&&(r.stepBackward(),r.stepBackward()),l?r.getCurrentTokenRange():(p=r.getCurrentTokenRow(),-1===g?new c(p,t.getLine(p).length,R,y):new c(R,y,p,r.getCurrentTokenColumn()))}},this.latexSection=function(t,n,o){var l=new k(t,n,o),e=l.getCurrentToken();if(e&&"storage.type"==e.type){for(var r=x[e.value]||0,i=0,s=n;e=l.stepForward();)if("storage.type"===e.type){var g=x[e.value]||0;if(g>=9){if(i||(s=l.getCurrentTokenRow()-1),(i+=9==g?1:-1)<0)break}else if(g>=r)break}for(i||(s=l.getCurrentTokenRow()-1);s>n&&!/\S/.test(t.getLine(s));)s--;return new c(n,t.getLine(n).length,s,t.getLine(s).length)}}}.call(u.prototype)}),ace.define("ace/mode/latex",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/latex_highlight_rules","ace/mode/behaviour/cstyle","ace/mode/folding/latex"],function(a,d,b){"use strict";var h=a("../lib/oop"),f=a("./text").Mode,c=a("./latex_highlight_rules").LatexHighlightRules,k=a("./behaviour/cstyle").CstyleBehaviour,x=a("./folding/latex").FoldMode,u=function(){this.HighlightRules=c,this.foldingRules=new x,this.$behaviour=new k({braces:!0})};h.inherits(u,f),function(){this.type="text",this.lineCommentStart="%",this.$id="ace/mode/latex",this.getMatching=function(t,n,o){null==n&&(n=t.selection.lead),"object"==typeof n&&(o=n.column,n=n.row);var l=t.getTokenAt(n,o);if(l&&("\\begin"==l.value||"\\end"==l.value))return this.foldingRules.latexBlock(t,n,o,!0)}}.call(u.prototype),d.Mode=u}),ace.require(["ace/mode/latex"],function(a){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=a)});