ace.define("ace/mode/smithy_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(o,h,p){"use strict";var m=o("../lib/oop"),d=o("./text_highlight_rules").TextHighlightRules,s=function(){this.$rules={start:[{include:"#comment"},{token:["meta.keyword.statement.smithy","variable.other.smithy","text","keyword.operator.smithy"],regex:/^(\$)(\s+.+)(\s*)(=)/},{token:["keyword.statement.smithy","text","entity.name.type.namespace.smithy"],regex:/^(namespace)(\s+)([A-Z-a-z0-9_\.#$-]+)/},{token:["keyword.statement.smithy","text","keyword.statement.smithy","text","entity.name.type.smithy"],regex:/^(use)(\s+)(shape|trait)(\s+)([A-Z-a-z0-9_\.#$-]+)\b/},{token:["keyword.statement.smithy","variable.other.smithy","text","keyword.operator.smithy"],regex:/^(metadata)(\s+.+)(\s*)(=)/},{token:["keyword.statement.smithy","text","entity.name.type.smithy"],regex:/^(apply|byte|short|integer|long|float|double|bigInteger|bigDecimal|boolean|blob|string|timestamp|service|resource|trait|list|map|set|structure|union|document)(\s+)([A-Z-a-z0-9_\.#$-]+)\b/},{token:["keyword.operator.smithy","text","entity.name.type.smithy","text","text","support.function.smithy","text","text","support.function.smithy"],regex:/^(operation)(\s+)([A-Z-a-z0-9_\.#$-]+)(\(.*\))(?:(\s*)(->)(\s*[A-Z-a-z0-9_\.#$-]+))?(?:(\s+)(errors))?/},{include:"#trait"},{token:["support.type.property-name.smithy","punctuation.separator.dictionary.pair.smithy"],regex:/([A-Z-a-z0-9_\.#$-]+)(:)/},{include:"#value"},{token:"keyword.other.smithy",regex:/\->/}],"#comment":[{include:"#doc_comment"},{include:"#line_comment"}],"#doc_comment":[{token:"comment.block.documentation.smithy",regex:/\/\/\/.*/}],"#line_comment":[{token:"comment.line.double-slash.smithy",regex:/\/\/.*/}],"#trait":[{token:["punctuation.definition.annotation.smithy","storage.type.annotation.smithy"],regex:/(@)([0-9a-zA-Z\.#-]+)/},{token:["punctuation.definition.annotation.smithy","punctuation.definition.object.end.smithy","meta.structure.smithy"],regex:/(@)([0-9a-zA-Z\.#-]+)(\()/,push:[{token:"punctuation.definition.object.end.smithy",regex:/\)/,next:"pop"},{include:"#value"},{include:"#object_inner"},{defaultToken:"meta.structure.smithy"}]}],"#value":[{include:"#constant"},{include:"#number"},{include:"#string"},{include:"#array"},{include:"#object"}],"#array":[{token:"punctuation.definition.array.begin.smithy",regex:/\[/,push:[{token:"punctuation.definition.array.end.smithy",regex:/\]/,next:"pop"},{include:"#comment"},{include:"#value"},{token:"punctuation.separator.array.smithy",regex:/,/},{token:"invalid.illegal.expected-array-separator.smithy",regex:/[^\s\]]/},{defaultToken:"meta.structure.array.smithy"}]}],"#constant":[{token:"constant.language.smithy",regex:/\b(?:true|false|null)\b/}],"#number":[{token:"constant.numeric.smithy",regex:/-?(?:0|[1-9]\d*)(?:(?:\.\d+)?(?:[eE][+-]?\d+)?)?/}],"#object":[{token:"punctuation.definition.dictionary.begin.smithy",regex:/\{/,push:[{token:"punctuation.definition.dictionary.end.smithy",regex:/\}/,next:"pop"},{include:"#trait"},{include:"#object_inner"},{defaultToken:"meta.structure.dictionary.smithy"}]}],"#object_inner":[{include:"#comment"},{include:"#string_key"},{token:"punctuation.separator.dictionary.key-value.smithy",regex:/:/,push:[{token:"punctuation.separator.dictionary.pair.smithy",regex:/,|(?=\})/,next:"pop"},{include:"#value"},{token:"invalid.illegal.expected-dictionary-separator.smithy",regex:/[^\s,]/},{defaultToken:"meta.structure.dictionary.value.smithy"}]},{token:"invalid.illegal.expected-dictionary-separator.smithy",regex:/[^\s\}]/}],"#string_key":[{include:"#identifier_key"},{include:"#dquote_key"},{include:"#squote_key"}],"#identifier_key":[{token:"support.type.property-name.smithy",regex:/[A-Z-a-z0-9_\.#$-]+/}],"#dquote_key":[{include:"#dquote"}],"#squote_key":[{include:"#squote"}],"#string":[{include:"#textblock"},{include:"#dquote"},{include:"#squote"},{include:"#identifier"}],"#textblock":[{token:"punctuation.definition.string.begin.smithy",regex:/"""/,push:[{token:"punctuation.definition.string.end.smithy",regex:/"""/,next:"pop"},{token:"constant.character.escape.smithy",regex:/\\./},{defaultToken:"string.quoted.double.smithy"}]}],"#dquote":[{token:"punctuation.definition.string.begin.smithy",regex:/"/,push:[{token:"punctuation.definition.string.end.smithy",regex:/"/,next:"pop"},{token:"constant.character.escape.smithy",regex:/\\./},{defaultToken:"string.quoted.double.smithy"}]}],"#squote":[{token:"punctuation.definition.string.begin.smithy",regex:/'/,push:[{token:"punctuation.definition.string.end.smithy",regex:/'/,next:"pop"},{token:"constant.character.escape.smithy",regex:/\\./},{defaultToken:"string.quoted.single.smithy"}]}],"#identifier":[{token:"storage.type.smithy",regex:/[A-Z-a-z_][A-Z-a-z0-9_\.#$-]*/}]},this.normalizeRules()};s.metaData={name:"Smithy",fileTypes:["smithy"],scopeName:"source.smithy",foldingStartMarker:"(\\{|\\[)\\s*",foldingStopMarker:"\\s*(\\}|\\])"},m.inherits(s,d),h.SmithyHighlightRules=s}),ace.define("ace/mode/matching_brace_outdent",["require","exports","module","ace/range"],function(o,h,p){"use strict";var m=o("../range").Range,d=function(){};(function(){this.checkOutdent=function(s,c){return!!/^\s+$/.test(s)&&/^\s*\}/.test(c)},this.autoOutdent=function(s,c){var i=s.getLine(c).match(/^(\s*\})/);if(!i)return 0;var t=i[1].length,a=s.findMatchingBracket({row:c,column:t});if(!a||a.row==c)return 0;var n=this.$getIndent(s.getLine(a.row));s.replace(new m(c,0,c,t-1),n)},this.$getIndent=function(s){return s.match(/^\s*/)[0]}}).call(d.prototype),h.MatchingBraceOutdent=d}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(o,h,p){"use strict";var m=o("../../lib/oop"),d=o("../../range").Range,s=o("./fold_mode").FoldMode,c=h.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};m.inherits(c,s),function(){this.foldingStartMarker=/([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,i,t){var a=e.getLine(t);if(this.singleLineBlockCommentRe.test(a)&&!this.startRegionRe.test(a)&&!this.tripleStarBlockCommentRe.test(a))return"";var n=this._getFoldWidgetBase(e,i,t);return!n&&this.startRegionRe.test(a)?"start":n},this.getFoldWidgetRange=function(e,i,t,a){var r,n=e.getLine(t);if(this.startRegionRe.test(n))return this.getCommentRegionBlock(e,n,t);if(r=n.match(this.foldingStartMarker)){var u=r.index;if(r[1])return this.openingBracketBlock(e,r[1],t,u);var l=e.getCommentFoldRange(t,u+r[0].length,1);return l&&!l.isMultiLine()&&(a?l=this.getSectionRange(e,t):"all"!=i&&(l=null)),l}return"markbegin"!==i&&(r=n.match(this.foldingStopMarker))?(u=r.index+r[0].length,r[1]?this.closingBracketBlock(e,r[1],t,u):e.getCommentFoldRange(t,u,-1)):void 0},this.getSectionRange=function(e,i){for(var t=e.getLine(i),a=t.search(/\S/),n=i,u=t.length,l=i+=1,r=e.getLength();++i<r;){var y=(t=e.getLine(i)).search(/\S/);if(-1!==y){if(a>y)break;var g=this.getFoldWidgetRange(e,"all",i);if(g){if(g.start.row<=n)break;if(g.isMultiLine())i=g.end.row;else if(a==y)break}l=i}}return new d(n,u,l,e.getLine(l).length)},this.getCommentRegionBlock=function(e,i,t){for(var a=i.search(/\s*$/),n=e.getLength(),u=t,l=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,r=1;++t<n;){i=e.getLine(t);var y=l.exec(i);if(y&&(y[1]?r--:r++,!r))break}if(t>u)return new d(u,a,t,i.length)}}.call(c.prototype)}),ace.define("ace/mode/smithy",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/smithy_highlight_rules","ace/mode/matching_brace_outdent","ace/mode/behaviour/cstyle","ace/mode/folding/cstyle"],function(o,h,p){"use strict";var m=o("../lib/oop"),d=o("./text").Mode,s=o("./smithy_highlight_rules").SmithyHighlightRules,c=o("./matching_brace_outdent").MatchingBraceOutdent,e=o("./behaviour/cstyle").CstyleBehaviour,i=o("./folding/cstyle").FoldMode,t=function(){this.HighlightRules=s,this.$outdent=new c,this.$behaviour=new e,this.foldingRules=new i};m.inherits(t,d),function(){this.lineCommentStart="//",this.$quotes={'"':'"'},this.checkOutdent=function(a,n,u){return this.$outdent.checkOutdent(n,u)},this.autoOutdent=function(a,n,u){this.$outdent.autoOutdent(n,u)},this.$id="ace/mode/smithy"}.call(t.prototype),h.Mode=t}),ace.require(["ace/mode/smithy"],function(o){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=o)});